/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the InteractionMutable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &InteractionMutable{}

// InteractionMutable struct for InteractionMutable
type InteractionMutable struct {
	Name string `json:"name"`
	Priority int32 `json:"priority"`
	ActionExecutionsLimit *int32 `json:"action_executions_limit,omitempty"`
	Trigger Trigger `json:"trigger"`
	Actions []Action `json:"actions"`
	Restart bool `json:"restart"`
	RestartCoolDown *string `json:"restart_cool_down,omitempty"`
	LiveFrom *time.Time `json:"live_from,omitempty"`
	LiveTo *time.Time `json:"live_to,omitempty"`
	Tags []string `json:"tags,omitempty"`
	Languages []string `json:"languages,omitempty"`
	Messengers []string `json:"messengers,omitempty"`
	TimeZone *string `json:"time_zone,omitempty"`
	DefaultLanguage *string `json:"default_language,omitempty"`
	CustomerExperienceId *string `json:"customer_experience_id,omitempty"`
	ForceNewTransaction bool `json:"force_new_transaction"`
}

// NewInteractionMutable instantiates a new InteractionMutable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewInteractionMutable(name string, priority int32, trigger Trigger, actions []Action, restart bool, forceNewTransaction bool) *InteractionMutable {
	this := InteractionMutable{}
	this.Name = name
	this.Priority = priority
	this.Trigger = trigger
	this.Actions = actions
	this.Restart = restart
	this.ForceNewTransaction = forceNewTransaction
	return &this
}

// NewInteractionMutableWithDefaults instantiates a new InteractionMutable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewInteractionMutableWithDefaults() *InteractionMutable {
	this := InteractionMutable{}
	return &this
}

// GetName returns the Name field value
func (o *InteractionMutable) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *InteractionMutable) SetName(v string) {
	o.Name = v
}

// GetPriority returns the Priority field value
func (o *InteractionMutable) GetPriority() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Priority
}

// GetPriorityOk returns a tuple with the Priority field value
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetPriorityOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Priority, true
}

// SetPriority sets field value
func (o *InteractionMutable) SetPriority(v int32) {
	o.Priority = v
}

// GetActionExecutionsLimit returns the ActionExecutionsLimit field value if set, zero value otherwise.
func (o *InteractionMutable) GetActionExecutionsLimit() int32 {
	if o == nil || IsNil(o.ActionExecutionsLimit) {
		var ret int32
		return ret
	}
	return *o.ActionExecutionsLimit
}

// GetActionExecutionsLimitOk returns a tuple with the ActionExecutionsLimit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetActionExecutionsLimitOk() (*int32, bool) {
	if o == nil || IsNil(o.ActionExecutionsLimit) {
		return nil, false
	}
	return o.ActionExecutionsLimit, true
}

// HasActionExecutionsLimit returns a boolean if a field has been set.
func (o *InteractionMutable) HasActionExecutionsLimit() bool {
	if o != nil && !IsNil(o.ActionExecutionsLimit) {
		return true
	}

	return false
}

// SetActionExecutionsLimit gets a reference to the given int32 and assigns it to the ActionExecutionsLimit field.
func (o *InteractionMutable) SetActionExecutionsLimit(v int32) {
	o.ActionExecutionsLimit = &v
}

// GetTrigger returns the Trigger field value
func (o *InteractionMutable) GetTrigger() Trigger {
	if o == nil {
		var ret Trigger
		return ret
	}

	return o.Trigger
}

// GetTriggerOk returns a tuple with the Trigger field value
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetTriggerOk() (*Trigger, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Trigger, true
}

// SetTrigger sets field value
func (o *InteractionMutable) SetTrigger(v Trigger) {
	o.Trigger = v
}

// GetActions returns the Actions field value
func (o *InteractionMutable) GetActions() []Action {
	if o == nil {
		var ret []Action
		return ret
	}

	return o.Actions
}

// GetActionsOk returns a tuple with the Actions field value
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetActionsOk() ([]Action, bool) {
	if o == nil {
		return nil, false
	}
	return o.Actions, true
}

// SetActions sets field value
func (o *InteractionMutable) SetActions(v []Action) {
	o.Actions = v
}

// GetRestart returns the Restart field value
func (o *InteractionMutable) GetRestart() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Restart
}

// GetRestartOk returns a tuple with the Restart field value
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetRestartOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Restart, true
}

// SetRestart sets field value
func (o *InteractionMutable) SetRestart(v bool) {
	o.Restart = v
}

// GetRestartCoolDown returns the RestartCoolDown field value if set, zero value otherwise.
func (o *InteractionMutable) GetRestartCoolDown() string {
	if o == nil || IsNil(o.RestartCoolDown) {
		var ret string
		return ret
	}
	return *o.RestartCoolDown
}

// GetRestartCoolDownOk returns a tuple with the RestartCoolDown field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetRestartCoolDownOk() (*string, bool) {
	if o == nil || IsNil(o.RestartCoolDown) {
		return nil, false
	}
	return o.RestartCoolDown, true
}

// HasRestartCoolDown returns a boolean if a field has been set.
func (o *InteractionMutable) HasRestartCoolDown() bool {
	if o != nil && !IsNil(o.RestartCoolDown) {
		return true
	}

	return false
}

// SetRestartCoolDown gets a reference to the given string and assigns it to the RestartCoolDown field.
func (o *InteractionMutable) SetRestartCoolDown(v string) {
	o.RestartCoolDown = &v
}

// GetLiveFrom returns the LiveFrom field value if set, zero value otherwise.
func (o *InteractionMutable) GetLiveFrom() time.Time {
	if o == nil || IsNil(o.LiveFrom) {
		var ret time.Time
		return ret
	}
	return *o.LiveFrom
}

// GetLiveFromOk returns a tuple with the LiveFrom field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetLiveFromOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LiveFrom) {
		return nil, false
	}
	return o.LiveFrom, true
}

// HasLiveFrom returns a boolean if a field has been set.
func (o *InteractionMutable) HasLiveFrom() bool {
	if o != nil && !IsNil(o.LiveFrom) {
		return true
	}

	return false
}

// SetLiveFrom gets a reference to the given time.Time and assigns it to the LiveFrom field.
func (o *InteractionMutable) SetLiveFrom(v time.Time) {
	o.LiveFrom = &v
}

// GetLiveTo returns the LiveTo field value if set, zero value otherwise.
func (o *InteractionMutable) GetLiveTo() time.Time {
	if o == nil || IsNil(o.LiveTo) {
		var ret time.Time
		return ret
	}
	return *o.LiveTo
}

// GetLiveToOk returns a tuple with the LiveTo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetLiveToOk() (*time.Time, bool) {
	if o == nil || IsNil(o.LiveTo) {
		return nil, false
	}
	return o.LiveTo, true
}

// HasLiveTo returns a boolean if a field has been set.
func (o *InteractionMutable) HasLiveTo() bool {
	if o != nil && !IsNil(o.LiveTo) {
		return true
	}

	return false
}

// SetLiveTo gets a reference to the given time.Time and assigns it to the LiveTo field.
func (o *InteractionMutable) SetLiveTo(v time.Time) {
	o.LiveTo = &v
}

// GetTags returns the Tags field value if set, zero value otherwise.
func (o *InteractionMutable) GetTags() []string {
	if o == nil || IsNil(o.Tags) {
		var ret []string
		return ret
	}
	return o.Tags
}

// GetTagsOk returns a tuple with the Tags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetTagsOk() ([]string, bool) {
	if o == nil || IsNil(o.Tags) {
		return nil, false
	}
	return o.Tags, true
}

// HasTags returns a boolean if a field has been set.
func (o *InteractionMutable) HasTags() bool {
	if o != nil && !IsNil(o.Tags) {
		return true
	}

	return false
}

// SetTags gets a reference to the given []string and assigns it to the Tags field.
func (o *InteractionMutable) SetTags(v []string) {
	o.Tags = v
}

// GetLanguages returns the Languages field value if set, zero value otherwise.
func (o *InteractionMutable) GetLanguages() []string {
	if o == nil || IsNil(o.Languages) {
		var ret []string
		return ret
	}
	return o.Languages
}

// GetLanguagesOk returns a tuple with the Languages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetLanguagesOk() ([]string, bool) {
	if o == nil || IsNil(o.Languages) {
		return nil, false
	}
	return o.Languages, true
}

// HasLanguages returns a boolean if a field has been set.
func (o *InteractionMutable) HasLanguages() bool {
	if o != nil && !IsNil(o.Languages) {
		return true
	}

	return false
}

// SetLanguages gets a reference to the given []string and assigns it to the Languages field.
func (o *InteractionMutable) SetLanguages(v []string) {
	o.Languages = v
}

// GetMessengers returns the Messengers field value if set, zero value otherwise.
func (o *InteractionMutable) GetMessengers() []string {
	if o == nil || IsNil(o.Messengers) {
		var ret []string
		return ret
	}
	return o.Messengers
}

// GetMessengersOk returns a tuple with the Messengers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetMessengersOk() ([]string, bool) {
	if o == nil || IsNil(o.Messengers) {
		return nil, false
	}
	return o.Messengers, true
}

// HasMessengers returns a boolean if a field has been set.
func (o *InteractionMutable) HasMessengers() bool {
	if o != nil && !IsNil(o.Messengers) {
		return true
	}

	return false
}

// SetMessengers gets a reference to the given []string and assigns it to the Messengers field.
func (o *InteractionMutable) SetMessengers(v []string) {
	o.Messengers = v
}

// GetTimeZone returns the TimeZone field value if set, zero value otherwise.
func (o *InteractionMutable) GetTimeZone() string {
	if o == nil || IsNil(o.TimeZone) {
		var ret string
		return ret
	}
	return *o.TimeZone
}

// GetTimeZoneOk returns a tuple with the TimeZone field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetTimeZoneOk() (*string, bool) {
	if o == nil || IsNil(o.TimeZone) {
		return nil, false
	}
	return o.TimeZone, true
}

// HasTimeZone returns a boolean if a field has been set.
func (o *InteractionMutable) HasTimeZone() bool {
	if o != nil && !IsNil(o.TimeZone) {
		return true
	}

	return false
}

// SetTimeZone gets a reference to the given string and assigns it to the TimeZone field.
func (o *InteractionMutable) SetTimeZone(v string) {
	o.TimeZone = &v
}

// GetDefaultLanguage returns the DefaultLanguage field value if set, zero value otherwise.
func (o *InteractionMutable) GetDefaultLanguage() string {
	if o == nil || IsNil(o.DefaultLanguage) {
		var ret string
		return ret
	}
	return *o.DefaultLanguage
}

// GetDefaultLanguageOk returns a tuple with the DefaultLanguage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetDefaultLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.DefaultLanguage) {
		return nil, false
	}
	return o.DefaultLanguage, true
}

// HasDefaultLanguage returns a boolean if a field has been set.
func (o *InteractionMutable) HasDefaultLanguage() bool {
	if o != nil && !IsNil(o.DefaultLanguage) {
		return true
	}

	return false
}

// SetDefaultLanguage gets a reference to the given string and assigns it to the DefaultLanguage field.
func (o *InteractionMutable) SetDefaultLanguage(v string) {
	o.DefaultLanguage = &v
}

// GetCustomerExperienceId returns the CustomerExperienceId field value if set, zero value otherwise.
func (o *InteractionMutable) GetCustomerExperienceId() string {
	if o == nil || IsNil(o.CustomerExperienceId) {
		var ret string
		return ret
	}
	return *o.CustomerExperienceId
}

// GetCustomerExperienceIdOk returns a tuple with the CustomerExperienceId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetCustomerExperienceIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerExperienceId) {
		return nil, false
	}
	return o.CustomerExperienceId, true
}

// HasCustomerExperienceId returns a boolean if a field has been set.
func (o *InteractionMutable) HasCustomerExperienceId() bool {
	if o != nil && !IsNil(o.CustomerExperienceId) {
		return true
	}

	return false
}

// SetCustomerExperienceId gets a reference to the given string and assigns it to the CustomerExperienceId field.
func (o *InteractionMutable) SetCustomerExperienceId(v string) {
	o.CustomerExperienceId = &v
}

// GetForceNewTransaction returns the ForceNewTransaction field value
func (o *InteractionMutable) GetForceNewTransaction() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.ForceNewTransaction
}

// GetForceNewTransactionOk returns a tuple with the ForceNewTransaction field value
// and a boolean to check if the value has been set.
func (o *InteractionMutable) GetForceNewTransactionOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ForceNewTransaction, true
}

// SetForceNewTransaction sets field value
func (o *InteractionMutable) SetForceNewTransaction(v bool) {
	o.ForceNewTransaction = v
}

func (o InteractionMutable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o InteractionMutable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["name"] = o.Name
	toSerialize["priority"] = o.Priority
	if !IsNil(o.ActionExecutionsLimit) {
		toSerialize["action_executions_limit"] = o.ActionExecutionsLimit
	}
	toSerialize["trigger"] = o.Trigger
	toSerialize["actions"] = o.Actions
	toSerialize["restart"] = o.Restart
	if !IsNil(o.RestartCoolDown) {
		toSerialize["restart_cool_down"] = o.RestartCoolDown
	}
	if !IsNil(o.LiveFrom) {
		toSerialize["live_from"] = o.LiveFrom
	}
	if !IsNil(o.LiveTo) {
		toSerialize["live_to"] = o.LiveTo
	}
	if !IsNil(o.Tags) {
		toSerialize["tags"] = o.Tags
	}
	if !IsNil(o.Languages) {
		toSerialize["languages"] = o.Languages
	}
	if !IsNil(o.Messengers) {
		toSerialize["messengers"] = o.Messengers
	}
	if !IsNil(o.TimeZone) {
		toSerialize["time_zone"] = o.TimeZone
	}
	if !IsNil(o.DefaultLanguage) {
		toSerialize["default_language"] = o.DefaultLanguage
	}
	if !IsNil(o.CustomerExperienceId) {
		toSerialize["customer_experience_id"] = o.CustomerExperienceId
	}
	toSerialize["force_new_transaction"] = o.ForceNewTransaction
	return toSerialize, nil
}

type NullableInteractionMutable struct {
	value *InteractionMutable
	isSet bool
}

func (v NullableInteractionMutable) Get() *InteractionMutable {
	return v.value
}

func (v *NullableInteractionMutable) Set(val *InteractionMutable) {
	v.value = val
	v.isSet = true
}

func (v NullableInteractionMutable) IsSet() bool {
	return v.isSet
}

func (v *NullableInteractionMutable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableInteractionMutable(val *InteractionMutable) *NullableInteractionMutable {
	return &NullableInteractionMutable{value: val, isSet: true}
}

func (v NullableInteractionMutable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableInteractionMutable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


